﻿/* esta classe ira controlar a criação dinamica dos elementos quimicos*/
package{

// importação dos packages auxiliares
import flash.display.MovieClip;
import flash.events.MouseEvent;
import flash.events.Event;	
import flash.events.EventDispatcher;
import flash.events.Event;
import flash.geom.*;
import fl.motion.*;
import flash.display.DisplayObject;
import flash.display.Graphics;
import flash.display.Shape;
import flash.display.Sprite;
import flash.text.TextField;
import flash.text.TextFormat;
import flash.text.TextFieldAutoSize;
import flash.display.Loader;
import flash.events.*;
import flash.net.URLRequest;

	
	public class Elemento extends MovieClip{
		
		//declaração das variaveis que controlam o numero de ligações totais permitidas e realizadas
		var ligacaoTotal:Number;
		var ligacaoFeita:Number=0;
		
		var ligacoes=new Array();
		var posIni:Point=new Point(0,0);
		// variaveis que carregaram o swf que contem a imagem do atomo e o armazenam
		var ball:MovieClip=new MovieClip();
		var loader:Loader = new Loader();
        var nome:String;
		
		//variavel que armazena o raio da circunferencia
		var raio:Number;
		
			//construtor da classe Elemento
			public function Elemento(link:String,ligacao:Number,ini:Point){
				
				// variavel que realiza a requisição do swf que contem o obj
				var endereco:URLRequest = new URLRequest(link);
				nome=link;
				// inicia o download da variavel
				loader.load(endereco);
				posIni=ini;
				// listener de termino do download do swf
				loader.contentLoaderInfo.addEventListener(Event.COMPLETE, onComplete);

				//passagem do valor do numero total de ligações
				ligacaoTotal=ligacao;
				}// fim do construtor 
			
			// função que repassa o arquivo baixado para a variavel ball
			function onComplete(event:Event):void{
    	        
				// se o conteudo de loader for diferente de vazio realiza a repasse
				if (loader.content!= null){
        			// atribui o conteudo de loader a ball e adiciona o mesmo ao stage
					ball=loader.content as MovieClip;
					ball=ball.element;
					addChild(ball);
					trace(ball);
					// reduz o tamanho do MC a 60% do original
					
					
					ball.width*=0.6;
					ball.height*=0.6;
					gotoLast();
					raio=(ball.height/2);
					gotoRight();
					//posIni.y-=(ball.height/2);
					// configura o listener de movimentação do objeto
					this.addEventListener(MouseEvent.MOUSE_DOWN,mexe);
				}else{// se loader for nulo repassa a mensagem de erro
        			trace("loader is not a URLLoader!");
    			}
			}// fim do metodo onComplete
			
			
			// função que trata o arrastamento do objeto
			
			function mexe(event:MouseEvent){
				
				this.startDrag();
				
				// configura listener de parada do objeto
				
				stage.addEventListener(MouseEvent.MOUSE_UP,para);
			}// fim da função mexe
			
			// função que trata a parada do objeto
			
			function para(event:MouseEvent){
				
				this.stopDrag();
			
				// remoção do listener de parada
			
				stage.removeEventListener(MouseEvent.MOUSE_UP,para);
				
				// dispara um evento para o stage indicando a parada do objeto
				this.dispatchEvent(new Event("para"));
			}// fim da função para
			
			// função que incrementa numero de ligações feitas se possivel ou retorna false
			public function setLigacao(lig:Number):Boolean{
				trace("vai adicionar: "+lig);
				if(ligacaoFeita>=ligacaoTotal)
					return false;
				else{
					ligacaoFeita++;
					ligacoes.push(lig);
					ball.nextFrame();
					trace("add: "+ball.element);
					return true;
				}
					
			}// fim da função setLigacao
			
			// função de decrementa uma ligacao
			public function unsetLigacao(lig:Number){
				trace("tem que tirar: "+lig);
				if(ligacaoFeita>0){
					ligacaoFeita--;
					ball.prevFrame();
					removeElemento(lig);
				}
				trace("sobraram: "+ligacoes);
			}// fim da função unsetLigacao
			
			function removeElemento(lig:Number){
				var i:Number,j:Number;
				var swap:Number;
				for(i=0;i<ligacoes.length;i++){
					if(ligacoes[i]==lig)
					break;
				} 
				for(j=i;j<ligacoes.length-1;j++){
					swap=ligacoes[j];
					ligacoes[j]=ligacoes[j+1];
					ligacoes[j+1]=swap;
				}
				ligacoes.pop();
			}
			
			public function unsetAll(){
				ligacoes=new Array();
				ball.gotoAndStop(1);
				ligacaoFeita=0;
				trace("number:"+ligacoes);
			}
			
			public function passaLigacoes():Array{
				return ligacoes;
			}
			
			// função que pega um elemento do aray de ligações e o coloca na frente dos demais
			public function reposiciona(pos:Number){
				var aux:Number,swap:Number;
				for(aux=ligacoes.length-1;aux>pos;aux--){
					swap=ligacoes[aux];
					ligacoes[aux]=ligacoes[aux-1];
					ligacoes[aux-1]=swap;
				}
			}
			
			
			
			public function getNome():String{
				return nome;
			}
			
			public function inicio(){
			this.x=posIni.x;
			this.y=posIni.y;
			}
			// retorna o numero de ligacoes que não foram usadas
			public function falta():Number{
				return ligacaoTotal-ligacaoFeita;
			}
			
			public function getRaio():Number{
				return raio;
			}
			
			// função que vai para o ultimo frame do mc, aquele que naum possui atomos em torno dele
			public function gotoLast(){
				ball.gotoAndStop(ball.totalFrames);
			} 
			
			// vai para o frame corresponde ao numero de ligações realizadas
			public function gotoRight(){
				ball.gotoAndStop(ligacaoFeita+1);
			}
	
	}// fim da classe Elemento

}// fim do package