﻿/* esta classe ira controlar a criação dinamica das ligações entre os atomos*/
package{

// importação dos packages auxiliares
import flash.display.MovieClip;
import flash.events.MouseEvent;
import flash.events.Event;	
import flash.events.EventDispatcher;
import flash.geom.*;
import fl.motion.*;
import flash.display.DisplayObject;
import flash.display.Graphics;
import flash.display.Shape;
import flash.display.Sprite;



	
	public class Ligacao extends MovieClip{
		
		// criação da variavel que ira conter as informações do desenho da ligação
		var reta:Shape = new Shape();
       	// variavel que armazena se a ligação esta sendo usada e se sim por quais atomos
		var elemento1:Number=-1,elemento2:Number=-1;
        // variavel que recebe a posição no atomo que a ligação esta se ela estiver sendo usada
		var posicao1:String="",posicao2:String="";
		// variavel que verifica se a posição da ligação é a 0 caso ela faça parte de uma ligação dupla ou tripla
		var zero:Number=-1;           
		
		var travar:Boolean=false;
		
		var posIni:Point=new Point(0,0);
			
			//construtor da classe Ligacao
			public function Ligacao(ini:Point){
				
				// desenha a reta
				reta.graphics.beginFill(0x000000);
				reta.graphics.lineStyle(1.5,0x000000);
				reta.graphics.drawRect(0,0,20,1);
				reta.graphics.endFill();
				
				// adicona a reta ao objeto
				addChild(reta);
				posIni=ini;
				// configura o listener para iniciar o drag do objeto
				
				this.addEventListener(MouseEvent.MOUSE_DOWN,mexe);
				
	
			}// fim do construtor 
			
			// função que trata o arrastamento do objeto
			
			function mexe(event:MouseEvent){
				// inicia o arrastamento
				trace("start drag!!");
				this.startDrag();
				
				// configura o listener de movimentação do objeto
				stage.addEventListener(MouseEvent.MOUSE_MOVE,verifica);
				// configura o listener para giro do mouse se houver um click
				this.addEventListener(MouseEvent.CLICK,gira);
				// configura listener de parada do objeto
				stage.addEventListener(MouseEvent.MOUSE_UP,para);
			}// fim da função mexe
			
			
			/* função que reage a movintação do objeto em MOUSE_DOWN e cancela o 
			evento de clique instanciado na função mexe*/
			
			function verifica(event:MouseEvent){
				this.removeEventListener(MouseEvent.CLICK,gira);
			}
			
			// função que trata a parada do objeto
			
			function para(event:MouseEvent){
			this.stopDrag();
			
			// remoção dos listeners de parada e movimento
			stage.removeEventListener(MouseEvent.MOUSE_MOVE,verifica);
			stage.removeEventListener(MouseEvent.MOUSE_UP,para);
			
			// dispacha um evento para o palco indicando a parada do objeto
			this.dispatchEvent(new Event("parou"));
			}// fim da função para
			
			// função que trata a rotação da linha
			
			function gira(event:MouseEvent){
				if(travar==false){
					trace("trav: "+travar);
					this.rotation+=45;
						if(this.rotation<0){
							this.rotation+=180;	
						}else if(this.rotation==180){
							this.rotation=0;
						}
				}
				
			}// fim da função gira
			
			// função que retorna o angulo da ligação
			public function getAngulo():Number{
				return this.rotation;
			}// fim da função getAngulo
			
			public function setElemento(i:Number,pos:String){
				
				if(elemento1==-1){
				elemento1=i;
				posicao1=pos;
				}
				else if(elemento2==-1){
				elemento2=i;
				posicao2=pos;
				}
				travar=true;
				
			}
			
			public function unsetElemento(i:Number){
				if(elemento1==i){
					elemento1=-1;
					posicao1="";
				}else if (elemento2==i){
					elemento2=-1;
					posicao2="";
				}
				trace("1: "+elemento1);
				trace("2: "+elemento2);
			}
			
			public function unsetAll(){
				
				elemento1=-1;
				elemento2=-1;
				posicao1="";
				posicao2="";
				
			}
			
			public function destravar(){
				travar=false;
			}
			
			
			
			public function getElemento():Array{
				
				return new Array(elemento1,elemento2);
			}
			
			public function getPosicao():Array{
				return new Array(posicao1,posicao2);
			}
			
			public function getZero():Number{
				return zero;
			}
			
			public function setZero(n:Number){
				zero=n;
			}
			
			public function resetAng(){
				this.rotation=0;	
			}
			
			public function inicio(){
				this.x=posIni.x;
				this.y=posIni.y;
			}
			
			
	}// fim da classe Ligacao

}// fim do package